#include <stdio.h>
#include "memory.h"
#include "camou.h"
#include "t.h"

static void upcall(int x){
	printf("C Upcall %d\n", x);
}

static void (*traptab[16])(int);

void (*signal(int sig, void (*trap)(int)))(int){
	void (*old)(int) = traptab[sig];

	traptab[sig] = trap;
	return old;
}

void kill(int sig){
	T_callback_sig_handler(traptab[sig], sig);
}

value tmp_main(value unit){
	char *news;
	T_int_list_t l;

	camou_init();
	printf("I'm in tmp_main!\n");

	/* Testing simple call.
	 */
	printf("This should print 3: %d\n", T_add(1, 2));

	/* Testing ML function that calls C upcall.
	 */
	T_add_up(1, 2, upcall);

	/* Testing ML function that calls ML upcall.
	 */
	T_add_up(1, 2, T_upcall());

	/* Testing C string argument passing.
	 */
	T_print("String defined in C");

	/* Testing ML string return and argument passing.
	 */
	news = T_news();
	T_print(news);

	/* Testing lists.
	 */
	l = T_get_list();
	printf("Sum %d\n", T_sum(l));
	printf("Length %d\n", T_length(camou_alloc(c2ml_T_int_list_t(l))));

	/* Testing ML to C interfacing.
	 */
	T_comp_string("good-bye");
	T_comp_string("hello");
	T_test_sig();

	return Val_unit;
}
